=== debian/changelog ===
ats-lang-anairiats (0.2.5-1) unstable; urgency=low

  * New upstream release (Closes: #645134)
  * Fixes build (Closes: #633300)

 -- Matthew Danish <mrd@debian.org>  Wed, 12 Oct 2011 18:17:09 -0400
